/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "xcom.h"
#include "patcher.h"

#define SHORTCUT_ENDTURN 1
#define SHORTCUT_MULTILEVELVIEW 2
#define SHORTCUT_SHOWMAP 3
#define SHORTCUT_CENTER 4
#define SHORTCUT_INVENTORY 5
#define SHORTCUT_KNEEL 6
#define SHORTCUT_NEXT 7
#define SHORTCUT_NEXT_SKIP 8
#define SHORTCUT_VIEWUP 9
#define SHORTCUT_VIEWDOWN 10
#define SHORTCUT_GOUP 11
#define SHORTCUT_GODOWN 12
#define SHORTCUT_LEFTMENU 13
#define SHORTCUT_RIGHTMENU 14
#define SHORTCUT_STATS 15
#define SHORTCUT_OPTIONS 16
#define SHORTCUT_LIFTOFF 17
#define SHORTCUT_RESERVENONE 18
#define SHORTCUT_RESERVESNAP 19
#define SHORTCUT_RESERVEAUTO 20
#define SHORTCUT_RESERVEAIMED 21

static short shortcut=-1;
static int mouse_wheel=0;
static int mouse_hwheel=0;
static int isSavingGame=0;
static unsigned char keyToShortcut[256];

#define MAPKEY(name,vk) if(!stricmp(str,name)) return vk;
static unsigned char strToVk(const char *str)
{
	MAPKEY("Back",VK_BACK);
	MAPKEY("BackSpace",VK_BACK);
	MAPKEY("Back Space",VK_BACK);
	MAPKEY("Tab",VK_TAB);
	MAPKEY("Clear",VK_CLEAR);
	MAPKEY("Return",VK_RETURN);
	MAPKEY("Enter",VK_RETURN);
	MAPKEY("Shift",VK_SHIFT);
	MAPKEY("Control",VK_CONTROL);
	MAPKEY("Menu",VK_MENU);
	MAPKEY("Pause",VK_PAUSE);
	MAPKEY("Escape",VK_ESCAPE);
	MAPKEY("Space",VK_SPACE);
	MAPKEY("Prior",VK_PRIOR);
	MAPKEY("PageUp",VK_PRIOR);
	MAPKEY("Next",VK_NEXT);
	MAPKEY("PageDown",VK_NEXT);
	MAPKEY("End",VK_END);
	MAPKEY("Home",VK_HOME);
	MAPKEY("Left",VK_LEFT);
	MAPKEY("Up",VK_UP);
	MAPKEY("Right",VK_RIGHT);
	MAPKEY("Down",VK_DOWN);
	MAPKEY("Print",VK_PRINT);
	MAPKEY("Insert",VK_INSERT);
	MAPKEY("Delete",VK_DELETE);
	MAPKEY("Num0",VK_NUMPAD0);
	MAPKEY("Numpad0",VK_NUMPAD0);
	MAPKEY("Num1",VK_NUMPAD1);
	MAPKEY("Numpad1",VK_NUMPAD1);
	MAPKEY("Num2",VK_NUMPAD2);
	MAPKEY("Numpad2",VK_NUMPAD2);
	MAPKEY("Num3",VK_NUMPAD3);
	MAPKEY("Numpad3",VK_NUMPAD3);
	MAPKEY("Num4",VK_NUMPAD4);
	MAPKEY("Numpad4",VK_NUMPAD4);
	MAPKEY("Num5",VK_NUMPAD5);
	MAPKEY("Numpad5",VK_NUMPAD5);
	MAPKEY("Num6",VK_NUMPAD6);
	MAPKEY("Numpad6",VK_NUMPAD6);
	MAPKEY("Num7",VK_NUMPAD7);
	MAPKEY("Numpad7",VK_NUMPAD7);
	MAPKEY("Num8",VK_NUMPAD8);
	MAPKEY("Numpad8",VK_NUMPAD8);
	MAPKEY("Num9",VK_NUMPAD9);
	MAPKEY("Numpad9",VK_NUMPAD9);
	MAPKEY("Multiply",VK_MULTIPLY);
	MAPKEY("Add",VK_ADD);
	MAPKEY("Separator",VK_SEPARATOR);
	MAPKEY("Subtract",VK_SUBTRACT);
	MAPKEY("Decimal",VK_DECIMAL);
	MAPKEY("Divide",VK_DIVIDE);
	MAPKEY("F1",VK_F1);
	MAPKEY("F2",VK_F2);
	MAPKEY("F3",VK_F3);
	MAPKEY("F4",VK_F4);
	MAPKEY("F5",VK_F5);
	MAPKEY("F6",VK_F6);
	MAPKEY("F7",VK_F7);
	MAPKEY("F8",VK_F8);
	MAPKEY("F9",VK_F9);
	MAPKEY("F10",VK_F10);
	MAPKEY("F11",VK_F11);
	MAPKEY("F12",VK_F12);
	MAPKEY("MouseMiddle",VK_MBUTTON)
	MAPKEY("MouseX1",VK_XBUTTON1)
	MAPKEY("MouseX2",VK_XBUTTON2)

//0x88 - 0x8F unassigned range
	MAPKEY("MouseWheelUp",0x88)
	MAPKEY("MouseWheelDown",0x89)
	MAPKEY("MouseWheelLeft",0x8a)
	MAPKEY("MouseWheelRight",0x8b)

	return 0;
}

unsigned char vkFromName(const char *str)
{
	if(strlen(str)==0)
		return 0;
	if(strlen(str)==1)
		return *str;
	if(!strncmp(str,"0x",2))
		return (char)strtol(str,NULL,16);
	return strToVk(str);
}


#define ADD_SHORTCUT(str,shortcut) do { INI_READ_STRING("Shortcuts",str,"",tmp,63); keyToShortcut[vkFromName(tmp)]=shortcut; } while(0);
void InitShortcutsTable()
{
	char tmp[64];
	memset(keyToShortcut,0,sizeof(keyToShortcut));

	ADD_SHORTCUT("End Turn",SHORTCUT_ENDTURN);
	ADD_SHORTCUT("Multilevel View",SHORTCUT_MULTILEVELVIEW);
	ADD_SHORTCUT("Show Map",SHORTCUT_SHOWMAP);
	ADD_SHORTCUT("Center On Unit",SHORTCUT_CENTER);
	ADD_SHORTCUT("Inventory",SHORTCUT_INVENTORY);
	ADD_SHORTCUT("Kneel",SHORTCUT_KNEEL);
	ADD_SHORTCUT("Next Unit",SHORTCUT_NEXT);
	ADD_SHORTCUT("Next Unit Skip Current",SHORTCUT_NEXT_SKIP);
	ADD_SHORTCUT("View Up",SHORTCUT_VIEWUP);
	ADD_SHORTCUT("View Down",SHORTCUT_VIEWDOWN);
	ADD_SHORTCUT("Go Up",SHORTCUT_GOUP);
	ADD_SHORTCUT("Go Down",SHORTCUT_GODOWN);
	ADD_SHORTCUT("Left Menu",SHORTCUT_LEFTMENU);
	ADD_SHORTCUT("Right Menu",SHORTCUT_RIGHTMENU);
	ADD_SHORTCUT("Unit Stats",SHORTCUT_STATS);
	ADD_SHORTCUT("Options",SHORTCUT_OPTIONS);
	ADD_SHORTCUT("Lift Off",SHORTCUT_LIFTOFF);
	ADD_SHORTCUT("Reserve None",SHORTCUT_RESERVENONE);
	ADD_SHORTCUT("Reserve Snap",SHORTCUT_RESERVESNAP);
	ADD_SHORTCUT("Reserve Auto",SHORTCUT_RESERVEAUTO);
	ADD_SHORTCUT("Reserve Aimed",SHORTCUT_RESERVEAIMED);
	keyToShortcut[0]=0;
}


void CheckShortcut()
{
	if(shortcut!=-1)
	{
		StatusBarClicked(shortcut);
		shortcut=-1;
	}
	else
	{
		CheckIfClickedOnStatusBar();
	}
}
/*
static int keyPressed=0;
static unsigned char key;

int CheckKeyboardState()
{
	return keyPressed?1:0;
}
int GetPressedKey()
{
	keyPressed=0;
	return key;
}
*/
LRESULT __stdcall MyDefWindowProcA(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
#if 0
	if(Msg==WM_CHAR)
	{
		*HasKeyBeenPressed=1;
		key=wParam;
		keyPressed=1;
		/*
		if(*IsTacticalMode==1&&*tactical_mainState==1)
		{
			switch(key)
			{
			case '1':
				shortcut=SHORTCUT_RESERVENONE;
				break;
			case '2':
				shortcut=SHORTCUT_RESERVESNAP;
				break;
			case '3':
				shortcut=SHORTCUT_RESERVEAUTO;
				break;
			case '4':
				shortcut=SHORTCUT_RESERVEAIMED;
				break;
			case '\t':
				shortcut=SHORTCUT_NEXT;
				break;
			case ' ':
				shortcut=SHORTCUT_INVENTORY;
				break;
			}
		}*/
	}
#endif
/*		
	MAPKEY("MouseWheelUp",0x88)
	MAPKEY("MouseWheelDown",0x89)
	MAPKEY("MouseWheelLeft",0x8a)
	MAPKEY("MouseWheelRight",0x8b)
*/
	if(Msg==WM_MOUSEWHEEL)
	{
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
		{
			mouse_wheel = GET_WHEEL_DELTA_WPARAM(wParam);
			if ( mouse_wheel > 0 )
			{
				shortcut=keyToShortcut[0x88];
			}
			else if ( mouse_wheel < 0 )
			{
				shortcut=keyToShortcut[0x89];
			}
		}
	}
	else if(Msg==WM_MOUSEHWHEEL)
	{
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
		{
			mouse_wheel = GET_WHEEL_DELTA_WPARAM(wParam);
			if ( mouse_wheel > 0 )
			{
				shortcut=keyToShortcut[0x8a];
			}
			else if ( mouse_wheel < 0 )
			{
				shortcut=keyToShortcut[0x8b];
			}
		}
	}
	else if(Msg==WM_MBUTTONDOWN)
	{
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
			shortcut=keyToShortcut[VK_MBUTTON];
	}
	else if(Msg==WM_XBUTTONDOWN)
	{
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
		{
			if(GET_XBUTTON_WPARAM (wParam) == XBUTTON1)
				shortcut=keyToShortcut[VK_XBUTTON1];
			else
				shortcut=keyToShortcut[VK_XBUTTON2];
		}
	}
	else if(Msg==WM_KEYDOWN)
	{
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
		{
			if(keyToShortcut[(char)wParam])
				shortcut=keyToShortcut[(char)wParam];
/*
			switch(wParam)
			{
			case VK_UP:
				shortcut=SHORTCUT_GOUP;
				break;
			case VK_DOWN:
				shortcut=SHORTCUT_GODOWN;
				break;
			case VK_LEFT:
				shortcut=SHORTCUT_LEFTMENU;
				break;
			case VK_RIGHT:
				shortcut=SHORTCUT_RIGHTMENU;
				break;
			case VK_RETURN:
				shortcut=SHORTCUT_ENDTURN;
				break;
			case VK_ESCAPE:
				shortcut=SHORTCUT_OPTIONS;
				break;
			case VK_BACK:
				shortcut=SHORTCUT_NEXT_SKIP;
				break;
			case VK_PRIOR:
				shortcut=SHORTCUT_VIEWUP;
				break;
			case VK_NEXT:
				shortcut=SHORTCUT_VIEWDOWN;
				break;

			case '1':
				shortcut=SHORTCUT_RESERVENONE;
				break;
			case '2':
				shortcut=SHORTCUT_RESERVESNAP;
				break;
			case '3':
				shortcut=SHORTCUT_RESERVEAUTO;
				break;
			case '4':
				shortcut=SHORTCUT_RESERVEAIMED;
				break;
			case '\t':
				shortcut=SHORTCUT_NEXT;
				break;
			case ' ':
				shortcut=SHORTCUT_INVENTORY;
				break;

			}
			*/
		}
		else
		{
			return 0;
		}
	}
	return DefWindowProcA(hWnd, Msg, wParam, lParam);
}

void ShowTacOptionScreen()
{
//.text:00412BCE E8 6D 29 00 00                call    ShowTacOptions                  ; case 0xF
	isSavingGame=1;
	((void (*)())(0x415540))();
	isSavingGame=0;
}

void Shortcuts()
{
/*
.text:0045E0FF C7 05 20 86 47 00 01 00 00 00 mov     HasKeyBeenPressed, 1            ; jumptable 0045E059 case 254
.text:0045E109 33 C0                         xor     eax, eax
.text:0045E10B C2 10 00                      retn    10h
*/
	char switchtable[]={4};
	//reroute key messages to DefWindowProcA
	InsertJmp(0x45E0FF,(void *)0x45E1D5);
	InsertJmp(0x45E113,(void *)0x45E1D5);
	PatchInPlace(0x45E318,switchtable,1);

//.text:0045E1D2 C2 10 00                      retn    10h
	Nop(0x45E1D0,5);

	//Hook DefWindowProcA
	Nop(0x45E1E5);
	InsertCall(0x45E1E6,MyDefWindowProcA);
	Nop(0x45E0EE);
	InsertCall(0x45E0EF,MyDefWindowProcA);

	//Shortcut handling
	InsertCall(0x42A82F,CheckShortcut);

	//Disable shortcut when typing savegame name
	InsertCall(0x412BCE,ShowTacOptionScreen);

	InitShortcutsTable();

//		InsertJmp(0x45E540,GetPressedKey);
//		InsertJmp(0x45E4E0,CheckKeyboardState);
}
